import React from 'react';
export interface SliderProps {
    value?: number;
    defaultValue?: number;
    min?: number;
    max?: number;
    step?: number;
    prefixCls?: string;
    onChange?: (value: number) => void;
    onBeforeChange?: (value: number) => void;
    onAfterChange?: (value: number) => void;
    vertical?: boolean;
    included?: boolean;
    disabled?: boolean;
    reverse?: boolean;
    minimumTrackStyle?: React.CSSProperties;
    trackStyle?: React.CSSProperties;
    handleStyle?: React.CSSProperties;
    tabIndex?: number;
    ariaLabelForHandle?: string;
    ariaLabelledByForHandle?: string;
    ariaValueTextFormatterForHandle?: string;
    startPoint?: number;
    handle: (props: {
        className: string;
        prefixCls?: string;
        vertical?: boolean;
        offset: number;
        value: number;
        dragging?: boolean;
        disabled?: boolean;
        min?: number;
        max?: number;
        reverse?: boolean;
        index: number;
        tabIndex?: number;
        ariaLabel: string;
        ariaLabelledBy: string;
        ariaValueTextFormatter: string;
        style?: React.CSSProperties;
        ref?: React.Ref<any>;
    }) => React.ReactElement;
}
export interface SliderState {
    value: number;
    dragging: boolean;
}
export declare class Slider extends React.Component<SliderProps, SliderState> {
    /**
     * [Legacy] Used for inherit other component.
     * It's a bad code style which should be refactor.
     */
    calcValueByPos(value: number): number;
    calcOffset(value: number): number;
    saveHandle(index: number, h: any): void;
    removeDocumentEvents(): void;
    constructor(props: SliderProps);
    startValue: number;
    startPosition: number;
    prevMovedHandleIndex: number;
    componentDidUpdate(_: SliderProps, prevState: SliderState): void;
    onChange(state: {
        value: number;
    }): void;
    onStart(position: number): void;
    onEnd: (force?: boolean) => void;
    onMove(e: any, position: any): void;
    onKeyboard(e: any): void;
    getValue(): number;
    getLowerBound(): number;
    getUpperBound(): number;
    trimAlignValue(v: number, nextProps?: Partial<SliderProps>): number;
    render(): {
        tracks: JSX.Element;
        handles: React.ReactElement<any, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)>) | (new (props: any) => React.Component<any, any, any>)>;
    };
}
declare const _default: any;
export default _default;
